﻿using System;
using System.Collections.Generic;
using System.Text;

namespace DMTTest
{
	internal static class Config
	{
		internal static System.TimeSpan Time = Properties.Settings.Default.Time;
		internal static System.TimeSpan TimeDec = Properties.Settings.Default.TimeDec;
		internal static int Answers = Properties.Settings.Default.Answers;
		internal static System.TimeSpan TimeMin = Properties.Settings.Default.TimeMin;
		internal static System.TimeSpan TimeResFalse = Properties.Settings.Default.TimeResFalse;
		internal static System.TimeSpan TimeResTrue = Properties.Settings.Default.TimeResTrue;
		internal static int[] Multipliers = ParseMultipliers(Properties.Settings.Default.Multipliers);

		static Config()
		{
			System.Globalization.CultureInfo curr = 
				System.Threading.Thread.CurrentThread.CurrentCulture;
			System.Threading.Thread.CurrentThread.CurrentCulture =
				System.Globalization.CultureInfo.InvariantCulture;
			try
			{
				string s = System.Configuration.ConfigurationManager.AppSettings["Time"];
				if (!string.IsNullOrEmpty(s))
				{
					Time = Decimal2TimeSpan(decimal.Parse(s));
				}
				s = System.Configuration.ConfigurationManager.AppSettings["TimeDec"];
				if (!string.IsNullOrEmpty(s))
				{
					TimeDec = Decimal2TimeSpan(decimal.Parse(s));
				}
				s = System.Configuration.ConfigurationManager.AppSettings["Answers"];
				if (!string.IsNullOrEmpty(s))
				{
					Answers = int.Parse(s);
				}
				s = System.Configuration.ConfigurationManager.AppSettings["TimeMin"];
				if (!string.IsNullOrEmpty(s))
				{
					TimeMin = Decimal2TimeSpan(decimal.Parse(s));
				}
				s = System.Configuration.ConfigurationManager.AppSettings["TimeResFalse"];
				if (!string.IsNullOrEmpty(s))
				{
					TimeResFalse = Decimal2TimeSpan(decimal.Parse(s));
				}
				s = System.Configuration.ConfigurationManager.AppSettings["TimeResTrue"];
				if (!string.IsNullOrEmpty(s))
				{
					TimeResTrue = Decimal2TimeSpan(decimal.Parse(s));
				}
				s = System.Configuration.ConfigurationManager.AppSettings["Multipliers"];
				if (!string.IsNullOrEmpty(s))
				{
					Multipliers = ParseMultipliers(s);
				}
			}
			finally
			{
				System.Threading.Thread.CurrentThread.CurrentCulture = curr;
			}
		}

		internal static decimal TimeSpan2Decimal(System.TimeSpan t)
		{
			return (decimal)t.TotalMilliseconds / 1000m;
		}
		internal static System.TimeSpan Decimal2TimeSpan(decimal d)
		{
			return new System.TimeSpan(0, 0, 0, 0, (int)(d * 1000m));
		}

		private static int[] ParseMultipliers(string sm)
		{
			string[] sma = sm.Split(',');
			int[] m = new int[sma.Length];
			for (int i = sma.Length; i-- > 0; )
			{
				m[i] = int.Parse(sma[i]);
				if (m[i] < 2 || m[i] > 9)
				{
					throw
						new System.ArgumentOutOfRangeException(
							string.Format(
								Properties.Resources.MultiplierOutOfRangeText,
								m[i],
								2,
								9
							)
						);
				}
			}
			return m;
		}
	}
}
