﻿using System;
using System.Collections.Generic;
using System.Text;

namespace DMTTest
{
	public static class Logger
	{
		//public static class Category
		//{
		//    public const string Event =		"LoggerEventText";
		//    public const string Info =		"LoggerInfoText";
		//    public const string Result =	"LoggerResultText";
		//    public const string Warning =	"LoggerWarningText";
		//    public const string Error =		"LoggerErrorText";
		//}

		private static object locker = new object();

		private static System.Diagnostics.BooleanSwitch events =
			new System.Diagnostics.BooleanSwitch(
				"events",
				"Log event messages",
				"0"
			);
		private static System.Diagnostics.BooleanSwitch eventsTime =
			new System.Diagnostics.BooleanSwitch(
				"eventsTime",
				"Log event messages time",
				"0"
			);
		private static System.Diagnostics.BooleanSwitch info =
			new System.Diagnostics.BooleanSwitch(
				"info",
				"Log info messages",
				"0"
			);
		private static System.Diagnostics.BooleanSwitch infoTime =
			new System.Diagnostics.BooleanSwitch(
				"infoTime",
				"Log info messages time",
				"0"
			);
		private static System.Diagnostics.BooleanSwitch results =
			new System.Diagnostics.BooleanSwitch(
				"results",
				"Log result messages",
				"1"
			);
		private static System.Diagnostics.BooleanSwitch resultsTime =
			new System.Diagnostics.BooleanSwitch(
				"resultsTime",
				"Log result messages time",
				"0"
			);
		private static System.Diagnostics.BooleanSwitch warnings =
			new System.Diagnostics.BooleanSwitch(
				"warnings",
				"Log warning messages",
				"1"
			);
		private static System.Diagnostics.BooleanSwitch warningsTime =
			new System.Diagnostics.BooleanSwitch(
				"warningsTime",
				"Log warning messages time",
				"0"
			);
		private static System.Diagnostics.BooleanSwitch errors =
			new System.Diagnostics.BooleanSwitch(
				"errors",
				"Log error messages",
				"1"
			);
		private static System.Diagnostics.BooleanSwitch errorsTime =
			new System.Diagnostics.BooleanSwitch(
				"errorsTime",
				"Log error messages time",
				"0"
			);
		private static System.Diagnostics.BooleanSwitch detailedExceptions =
			new System.Diagnostics.BooleanSwitch(
				"detailedExceptions",
				"Log exception details",
				"0"
			);

		public static void WriteEvent(string message)
		{
			if (!events.Enabled)
			{
				return;
			}
			lock (locker)
			{
				System.Diagnostics.Trace.WriteLine(
					GetMessage(eventsTime.Enabled, message),
					Properties.Resources.LoggerEventText
				);
				System.Diagnostics.Trace.Flush();
			}
		}

		public static void WriteInfo(string message)
		{
			if (!info.Enabled)
			{
				return;
			}
			lock (locker)
			{
				System.Diagnostics.Trace.WriteLine(
					GetMessage(infoTime.Enabled, message),
					Properties.Resources.LoggerInfoText
				);
				System.Diagnostics.Trace.Flush();
			}
		}

		public static void WriteResult(string message)
		{
			if (!results.Enabled)
			{
				return;
			}
			lock (locker)
			{
				System.Diagnostics.Trace.WriteLine(
					GetMessage(resultsTime.Enabled, message),
					Properties.Resources.LoggerResultText
				);
				System.Diagnostics.Trace.Flush();
			}
		}

		public static void WriteWarning(string message)
		{
			if (!warnings.Enabled)
			{
				return;
			}
			lock (locker)
			{
				System.Diagnostics.Trace.WriteLine(
					GetMessage(warningsTime.Enabled, message),
					Properties.Resources.LoggerWarningText
				);
				System.Diagnostics.Trace.Flush();
			}
		}

		public static void WriteError(string message)
		{
			if (!errors.Enabled)
			{
				return;
			}
			lock (locker)
			{
				System.Diagnostics.Trace.WriteLine(
					GetMessage(errorsTime.Enabled, message),
					Properties.Resources.LoggerErrorText
				);
				System.Diagnostics.Trace.Flush();
			}
		}

		public static void WriteError(System.Exception ex)
		{
			if (!errors.Enabled)
			{
				return;
			}
			lock (locker)
			{
				System.Diagnostics.Trace.WriteLine(
					GetMessage(errorsTime.Enabled, ex.Message),
					Properties.Resources.LoggerErrorText
				);
				if (detailedExceptions.Enabled)
				{
					System.Diagnostics.Trace.WriteLine(
						GetMessage(errorsTime.Enabled, ex.ToString()),
						Properties.Resources.LoggerErrorText
					);
				}
				System.Diagnostics.Trace.Flush();
			}
		}

		private static string GetMessage(bool timeEnabled, string msg)
		{
			StringBuilder sb = new StringBuilder();
			if (timeEnabled)
			{
				sb.Append(System.DateTime.Now.ToString(Properties.Resources.LoggerTimeFormat));
			}
			sb.Append(msg);
			return sb.ToString();
		}
	}
}
